/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package business;

import domain.Product;
import java.util.ArrayList;
import javax.annotation.PostConstruct;
import javax.ejb.ConcurrencyManagement;
import javax.ejb.ConcurrencyManagementType;
import javax.ejb.Lock;
import javax.ejb.LockType;
import javax.ejb.Singleton;

/**
 *
 * @author hardebolle
 */
@Singleton
@ConcurrencyManagement(ConcurrencyManagementType.CONTAINER)
public class CatalogSingleton {
    private ArrayList<Product> productList;
    
    public CatalogSingleton(){
        this.productList = new ArrayList<Product>();
    }

    @PostConstruct
    public void setup(){
        Product p = new Product();
        p.setName("iPad");
        p.setPrice(489.90);
        this.productList.add(p);
        p = new Product();
        p.setName("iPhone");
        p.setPrice(679.90);
        this.productList.add(p);

    }
    
    @Lock(LockType.READ)
    public ArrayList<Product> getProductList() {
        return productList;
    }
   
    @Lock(LockType.WRITE)
    public void add(Product newProduct) {
        this.productList.add(newProduct);
    }

    @Lock(LockType.WRITE)
    public void delete(Product p) {
        this.productList.remove(p);
    }
    
    
}
